# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from tf2_server/RequestTransformStreamRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class RequestTransformStreamRequest(genpy.Message):
  _md5sum = "0388653626cab9e5d086d306f4559803"
  _type = "tf2_server/RequestTransformStreamRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string parent_frame
string[] child_frames
bool intermediate_frames
duration publication_period
int32 publisher_queue_size
"""
  __slots__ = ['parent_frame','child_frames','intermediate_frames','publication_period','publisher_queue_size']
  _slot_types = ['string','string[]','bool','duration','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       parent_frame,child_frames,intermediate_frames,publication_period,publisher_queue_size

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RequestTransformStreamRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.parent_frame is None:
        self.parent_frame = ''
      if self.child_frames is None:
        self.child_frames = []
      if self.intermediate_frames is None:
        self.intermediate_frames = False
      if self.publication_period is None:
        self.publication_period = genpy.Duration()
      if self.publisher_queue_size is None:
        self.publisher_queue_size = 0
    else:
      self.parent_frame = ''
      self.child_frames = []
      self.intermediate_frames = False
      self.publication_period = genpy.Duration()
      self.publisher_queue_size = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.parent_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.child_frames)
      buff.write(_struct_I.pack(length))
      for val1 in self.child_frames:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      _x = self
      buff.write(_get_struct_B3i().pack(_x.intermediate_frames, _x.publication_period.secs, _x.publication_period.nsecs, _x.publisher_queue_size))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.publication_period is None:
        self.publication_period = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.parent_frame = str[start:end].decode('utf-8')
      else:
        self.parent_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.child_frames = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.child_frames.append(val1)
      _x = self
      start = end
      end += 13
      (_x.intermediate_frames, _x.publication_period.secs, _x.publication_period.nsecs, _x.publisher_queue_size,) = _get_struct_B3i().unpack(str[start:end])
      self.intermediate_frames = bool(self.intermediate_frames)
      self.publication_period.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.parent_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.child_frames)
      buff.write(_struct_I.pack(length))
      for val1 in self.child_frames:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      _x = self
      buff.write(_get_struct_B3i().pack(_x.intermediate_frames, _x.publication_period.secs, _x.publication_period.nsecs, _x.publisher_queue_size))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.publication_period is None:
        self.publication_period = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.parent_frame = str[start:end].decode('utf-8')
      else:
        self.parent_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.child_frames = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.child_frames.append(val1)
      _x = self
      start = end
      end += 13
      (_x.intermediate_frames, _x.publication_period.secs, _x.publication_period.nsecs, _x.publisher_queue_size,) = _get_struct_B3i().unpack(str[start:end])
      self.intermediate_frames = bool(self.intermediate_frames)
      self.publication_period.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B3i = None
def _get_struct_B3i():
    global _struct_B3i
    if _struct_B3i is None:
        _struct_B3i = struct.Struct("<B3i")
    return _struct_B3i
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from tf2_server/RequestTransformStreamResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RequestTransformStreamResponse(genpy.Message):
  _md5sum = "42ea15d06263d0e97103be7c351c819e"
  _type = "tf2_server/RequestTransformStreamResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string topic_name
string static_topic_name
"""
  __slots__ = ['topic_name','static_topic_name']
  _slot_types = ['string','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       topic_name,static_topic_name

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RequestTransformStreamResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.topic_name is None:
        self.topic_name = ''
      if self.static_topic_name is None:
        self.static_topic_name = ''
    else:
      self.topic_name = ''
      self.static_topic_name = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.topic_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.static_topic_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.topic_name = str[start:end].decode('utf-8')
      else:
        self.topic_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.static_topic_name = str[start:end].decode('utf-8')
      else:
        self.static_topic_name = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.topic_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.static_topic_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.topic_name = str[start:end].decode('utf-8')
      else:
        self.topic_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.static_topic_name = str[start:end].decode('utf-8')
      else:
        self.static_topic_name = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
class RequestTransformStream(object):
  _type          = 'tf2_server/RequestTransformStream'
  _md5sum = 'fdbc7cbc375cc5b1fb5343b20f44a099'
  _request_class  = RequestTransformStreamRequest
  _response_class = RequestTransformStreamResponse
